ThreadPoolExecutor.DiscardOldestPolicy (Java Platform SE 8 )
Keywords: java.util.concurrent.ThreadPoolExecutor.DiscardOldestPolicy class
Date: 2026-01-21

compact1, compact2, compact3
java.util.concurrent

## Class ThreadPoolExecutor.DiscardOldestPolicy

- java.lang.Object
- - java.util.concurrent.ThreadPoolExecutor.DiscardOldestPolicy

- All Implemented Interfaces:
    RejectedExecutionHandler
  Enclosing class:
    ThreadPoolExecutor

      public static class ThreadPoolExecutor.DiscardOldestPolicy
      extends Object
      implements RejectedExecutionHandler

  A handler for rejected tasks that discards the oldest unhandled request and then retries `execute`, unless the executor is shut down, in which case the task is discarded.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DiscardOldestPolicy()` Creates a `DiscardOldestPolicy` for the given executor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `rejectedExecution(Runnable r, ThreadPoolExecutor e)` Obtains and ignores the next task that the executor would otherwise execute, if one is immediately available, and then retries execution of task r, unless the executor is shut down, in which case task r is instead discarded.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DiscardOldestPolicy

          public DiscardOldestPolicy()

      Creates a `DiscardOldestPolicy` for the given executor.

  - ### Method Detail

    - #### rejectedExecution

          public void rejectedExecution(Runnable r,
                                        ThreadPoolExecutor e)

      Obtains and ignores the next task that the executor would otherwise execute, if one is immediately available, and then retries execution of task r, unless the executor is shut down, in which case task r is instead discarded.
      Specified by:
        `rejectedExecution` in interface `RejectedExecutionHandler`
      Parameters:
        `r` - the runnable task requested to be executed
        `e` - the executor attempting to execute this task

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.